#!/usr/bin/env python3

import os
import pytest
import sys
from   time import time

thisdir = os.path.dirname(os.path.abspath(__file__))
sys.path.append(os.path.join(thisdir, '..'))

from spiral import *

class TestClass:
    def test_known_successes(self, capsys):
        assert ronin.split('ABCFooBar')              == ['ABC', 'Foo', 'Bar']
        assert ronin.split('ASTVisitor')             == ['AST', 'Visitor']
        assert ronin.split('GPSmodule')              == ['GPS', 'module']
        assert ronin.split('JRApiWriter')            == ['JR', 'Api', 'Writer']
        assert ronin.split('JavaTokenMarker')        == ['Java', 'Token', 'Marker']
        assert ronin.split('PRINTHOOD')              == ['PRINT', 'HOOD']
        assert ronin.split('SqlList')                == ['Sql', 'List']
        assert ronin.split('TRAinfo')                == ['TRA', 'info']
        assert ronin.split('WMLTimerElementImpl')    == ['WML', 'Timer', 'Element', 'Impl']
        assert ronin.split('altscore')               == ['alt', 'score']
        assert ronin.split('argv')                   == ['argv']
        assert ronin.split('autocommit')             == ['autocommit']
        assert ronin.split('bigTHING')               == ['big', 'THING']
        assert ronin.split('calleeNode')             == ['callee', 'Node']
        assert ronin.split('cdimage')                == ['cd', 'image']
        assert ronin.split('cdplayer')               == ['cd', 'player']
        assert ronin.split('cmdextdir')              == ['cmd', 'ext', 'dir']
        assert ronin.split('connectpath')            == ['connect', 'path']
        assert ronin.split('csize')                  == ['c', 'size']
        assert ronin.split('farsidebag')             == ['far', 'side', 'bag']
        assert ronin.split('filesave')               == ['file', 'save']
        assert ronin.split('filesaveas')             == ['file', 'save', 'as']
        assert ronin.split('finalizeLength')         == ['finalize', 'Length']
        assert ronin.split('finditer')               == ['find', 'iter']
        assert ronin.split('getMAX')                 == ['get', 'MAX']
        assert ronin.split('getint')                 == ['get', 'int']
        assert ronin.split('getinteger')             == ['get', 'integer']
        assert ronin.split('getxy')                  == ['get', 'xy']
        assert ronin.split('gocompact')              == ['go', 'compact']
        assert ronin.split('hostloader')             == ['host', 'loader']
        assert ronin.split('httpexceptions')         == ['http', 'exceptions']
        assert ronin.split('ijException')            == ['ij', 'Exception']
        assert ronin.split('initVtbl')               == ['init', 'V', 'tbl']
        assert ronin.split('initdb')                 == ['init', 'db']
        assert ronin.split('iptool')                 == ['ip', 'tool']
        assert ronin.split('isbetterfile')           == ['is', 'better', 'file']
        assert ronin.split('isinstance')             == ['is', 'instance']
        assert ronin.split('iskeyword')              == ['is', 'keyword']
        assert ronin.split('isnumber')               == ['is', 'number']
        assert ronin.split('iwebnavigation')         == ['iweb', 'navigation']
        assert ronin.split('jrender')                == ['j', 'render']
        assert ronin.split('liquidweather')          == ['liquid', 'weather']
        assert ronin.split('m_pk2len')               == ['m', 'pk', '2', 'len']
        assert ronin.split('mixmonitor')             == ['mix', 'monitor']
        assert ronin.split('mpegts')                 == ['mpegts']
        assert ronin.split('mythread')               == ['my', 'thread']
        assert ronin.split('needsibm')               == ['needs', 'ibm']
        assert ronin.split('nonnegativedecimaltype') == ['nonnegative', 'decimal', 'type']
        assert ronin.split('nwritten')               == ['n', 'written']
        assert ronin.split('patternstok')            == ['patterns', 'tok']
        assert ronin.split('pcmret')                 == ['pcm', 'ret']
        assert ronin.split('pixellate')              == ['pixellate']
        assert ronin.split('readcmd')                == ['read', 'cmd']
        assert ronin.split('rescale')                == ['rescale']
        assert ronin.split('rthandler')              == ['rt', 'handler']
        assert ronin.split('sampfmt')                == ['samp', 'fmt']
        assert ronin.split('slimprojector')          == ['slim', 'projector']
        assert ronin.split('somevar')                == ['some', 'var']
        assert ronin.split('tagcount')               == ['tag', 'count']
        assert ronin.split('terraindata')            == ['terrain', 'data']
        assert ronin.split('textnode')               == ['text', 'node']
        assert ronin.split('threshold')              == ['threshold']
        assert ronin.split('trigname')               == ['trig', 'name']
        assert ronin.split('ullMax')                 == ['ull', 'Max']
        assert ronin.split('undirected')             == ['undirected']
        assert ronin.split('updatecpu')              == ['update', 'cpu']
        assert ronin.split('urlparser')              == ['url', 'parser']
        assert ronin.split('usage_getdata')          == ['usage', 'get', 'data']
        assert ronin.split('usemap')                 == ['use', 'map']
        assert ronin.split('versionend')             == ['version', 'end']
        assert ronin.split('vframe')                 == ['v', 'frame']
        assert ronin.split('wickedweather')          == ['wicked', 'weather']
        assert ronin.split('xmax')                   == ['x', 'max']
        assert ronin.split('xmin')                   == ['x', 'min']
        assert ronin.split('xmldoc')                 == ['xml', 'doc']

    def test_known_failures(self, capsys):
        assert ronin.split('driveourtrucks')      != ['drive', 'our', 'trucks']
        assert ronin.split('uval')                != ['u', 'val']
        assert ronin.split('hisip')               != ['his', 'ip']
        assert ronin.split('lunch_defendj')       != ['lunch', 'defend', 'j']
        assert ronin.split('sandcx')              != ['sandcx']
        assert ronin.split('numberoferrorgroups') != ['number', 'of', 'error', 'groups']
        assert ronin.split('thisisatest')         != ['this', 'is', 'a', 'test']
        assert ronin.split('singlexmin')          != ['single', 'x', 'min']
        assert ronin.split('icause')              != ['i', 'cause']
        assert ronin.split('argv')                != ['arg', 'v']
